# EchidnaLink

## API

Output and requested input values

socket.emit('event_name', option_object);

event name        option object

led         { name: <name>, action: action }                   | name = 'yellow' | 'green' | 'red'
                                                               | action = 'on' | 'off'
rgb         { action: 'color', color: <color_object>}          | color_object = {red: 10, green: 20, blue: 56}
                                                               |
rgb         { action: action }                                 | action = 'on'| 'off'
                                                               |
io          { id: <id_io>, action: 'write', value: <value>}    | id_io = 'io1' | 'io2' | 'io3'
                                                               | value = 1 | 0
io          { id: <id_io>, action: 'read' }                    | id_io = 'io1' | 'io2' | 'io3'
                                                               |
piezo       {                                                  |                
                action: 'frequency',                           |
                frequency: <frequency>,                        | frequency is the frequency in Hz
                duration: <duration>                           | duration is the duration in ms
            }                                                  |
piezo       {                                                  |
                action: 'play',                                | play a song
                tune: <tune>,                                  | tune is an array as mario_intro (see below)
                callback: <callback>                           | callback is a function to be executed when song is played,
            }                                                  | callback can be null

joystick    { action: 'read' }

accelerometer {action: 'read' }

ldr          { action: 'read' }

analog_in    { action: 'read' }

-----------
Input events

submit.on(event, data => {
    // code to deal with data
})

where event can be:

- 'button'

const mario_intro = {
    song: [
      ["E5", 1/4],
      [null, 1/4],
      ["E5", 1/4],
      [null, 3/4],
      ["E5", 1/4],
      [null, 3/4],
      ["C5", 1/4],
      [null, 1/4],
      ["E5", 1/4],
      [null, 3/4],
      ["G5", 1/4],
      [null, 7/4],
      ["G4", 1/4],
      [null, 7/4]
    ],
    tempo: 200
  };



piezo       { action: 'frequency', frequency: 440, duration: 1000}
## To Use

To clone and run this repository you'll need [Git](https://git-scm.com) and [Node.js](https://nodejs.org/en/download/) (which comes with [npm](http://npmjs.com)) installed on your computer. From your command line:

```bash
# Clone this repository
git clone https://github.com/electron/electron-quick-start
# Go into the repository
cd electron-quick-start
# Install dependencies
npm install
# Run the app
npm start
```

Note: If you're using Linux Bash for Windows, [see this guide](https://www.howtogeek.com/261575/how-to-run-graphical-linux-desktop-applications-from-windows-10s-bash-shell/) or use `node` from the command prompt.

## Resources for Learning Electron

- [electronjs.org/docs](https://electronjs.org/docs) - all of Electron's documentation
- [electronjs.org/community#boilerplates](https://electronjs.org/community#boilerplates) - sample starter apps created by the community
- [electron/electron-quick-start](https://github.com/electron/electron-quick-start) - a very basic starter Electron app
- [electron/simple-samples](https://github.com/electron/simple-samples) - small applications with ideas for taking them further
- [electron/electron-api-demos](https://github.com/electron/electron-api-demos) - an Electron app that teaches you how to use Electron
- [hokein/electron-sample-apps](https://github.com/hokein/electron-sample-apps) - small demo apps for the various Electron APIs
