const path = require('path');
const nativeImage = require('electron').nativeImage;
const { app, Menu, Tray, Notification } = require('electron')
const { echidnalink } = require('./echidnalink.js');

let tray = null;

app.on('ready', () => {
    const iconPath = path.join(__dirname, 'images/echidna_40_24.png');
    const trayIcon = nativeImage.createFromPath(iconPath);

    tray = new Tray(trayIcon);

    const contextMenu = Menu.buildFromTemplate([
        { label: 'EchidnaLink v1.2.2' },
        { type: 'separator' },
        { label: 'Salir', click() { app.quit() } },
    ])
    echidnalink.startLink(Notification);
    tray.setToolTip('EchidnaLink activo');
    tray.setContextMenu(contextMenu);

})